Subject: Re: iSCSI Querry !

From: [email-masked] (Sandeep Joshi)
Date: Sun, 11 Nov 2001 23:34:20 -0500 (EST)

(added iSCSI to the subject line..)

Steph,

I believe what is being suggested is similar to running nfsd 
in the kernel and making it hook up directly to the native
filesystem layer.   Its feasible provided you can solve all 
the associated problems ... N initiators, N connections, 
N LUNs, etc :-)

Kaushik, 

>  we would like to know if any group is working on 
>  implementing iscsi stack on FreeBSD.

yes, we have a FreeBSD-based iSCSI stack for target as well 
as initiator.   Some of it may be released to the community
in the near future.

-Sandeep

> Kaushik,
>
> > won't it be feasible if we can write a pseudo driver that takes care
> > of the fetching the scsi cdb as such and passing it on to the SIM
> > driver ? In a way we will get away from the PM functionality which
> > forms the scsi CDB in case of a normal I/O.    
> 
> I'm not quite sure what your proposing here, but something seems
> wrong.  Just fyi, I have worked on several CAM-based initiators (who
> was it that was saying CAM was never implemented?).
> 
> You have mentioned `iSCSI target stack' several times.  Are you trying
> to make FreeBSD behave like a storage target?  If so, you should
> probably not be using CAM at all.  CAM is about implementing
> initiators.  It does define a target mode path, but it is relatively
> limited in scope.  CAM target mode is good for implementing a SCSI
> processor target (for things like cluster communication and bus
> pinging), but I don't think it was intended for a richer target
> (e.g. a storage target).  It's defined for connectivity, but not
> performance in the target role.
>